require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ATR_DUAL)) {
    sub ATR_DUAL {
	my($y,$x) = @_;
	eval q(((($y) << 16) | ($x)));
    }
}
unless(defined(&ATR_CLIP_CONTROL)) {
    sub ATR_CLIP_CONTROL () {	0x30;}
}
unless(defined(&ATR_CLIP_LEFT)) {
    sub ATR_CLIP_LEFT () {	0x38;}
}
unless(defined(&ATR_CLIP_TOP)) {
    sub ATR_CLIP_TOP () {	0x3a;}
}
unless(defined(&ATR_CLIP_LEFTTOP)) {
    sub ATR_CLIP_LEFTTOP () {	0x38;}
}
unless(defined(&ATR_CLIP_RIGHT)) {
    sub ATR_CLIP_RIGHT () {	0x3c;}
}
unless(defined(&ATR_CLIP_BOTTOM)) {
    sub ATR_CLIP_BOTTOM () {	0x3e;}
}
unless(defined(&ATR_CLIP_RIGHTBOTTOM)) {
    sub ATR_CLIP_RIGHTBOTTOM () {	0x3c;}
}
unless(defined(&ATR_DEC)) {
    sub ATR_DEC () {	0x40;}
}
unless(defined(&ATR_ROP)) {
    sub ATR_ROP () {	0x46;}
}
unless(defined(&ATR_BYTEMASK)) {
    sub ATR_BYTEMASK () {	0x47;}
}
unless(defined(&ATR_PATTERN1)) {
    sub ATR_PATTERN1 () {	0x48;}
}
unless(defined(&ATR_PATTERN2)) {
    sub ATR_PATTERN2 () {	0x4c;}
}
unless(defined(&ATR_SRC_X)) {
    sub ATR_SRC_X () {	0x50;}
}
unless(defined(&ATR_SRC_Y)) {
    sub ATR_SRC_Y () {	0x52;}
}
unless(defined(&ATR_SRC_XY)) {
    sub ATR_SRC_XY () {	0x50;}
}
unless(defined(&ATR_DST_X)) {
    sub ATR_DST_X () {	0x54;}
}
unless(defined(&ATR_DST_Y)) {
    sub ATR_DST_Y () {	0x56;}
}
unless(defined(&ATR_DST_XY)) {
    sub ATR_DST_XY () {	0x54;}
}
unless(defined(&ATR_W)) {
    sub ATR_W () {	0x58;}
}
unless(defined(&ATR_H)) {
    sub ATR_H () {	0x5a;}
}
unless(defined(&ATR_WH)) {
    sub ATR_WH () {	0x58;}
}
unless(defined(&ATR_OFFSET)) {
    sub ATR_OFFSET () {	0x5c;}
}
unless(defined(&ATR_SRC_OFFSET)) {
    sub ATR_SRC_OFFSET () {	0x5e;}
}
unless(defined(&ATR_FG)) {
    sub ATR_FG () {	0x60;}
}
unless(defined(&ATR_BG)) {
    sub ATR_BG () {	0x64;}
}
unless(defined(&DEC_COMMAND_MASK)) {
    sub DEC_COMMAND_MASK () {	0x3f;}
}
unless(defined(&DEC_COMMAND_SHIFT)) {
    sub DEC_COMMAND_SHIFT () {	0;}
}
unless(defined(&DEC_DIR_X_REVERSE)) {
    sub DEC_DIR_X_REVERSE () {	0x40;}
}
unless(defined(&DEC_DIR_Y_REVERSE)) {
    sub DEC_DIR_Y_REVERSE () {	0x80;}
}
unless(defined(&DEC_DIR_Y_MAJOR)) {
    sub DEC_DIR_Y_MAJOR () {	0x100;}
}
unless(defined(&DEC_SRC_LINEAR)) {
    sub DEC_SRC_LINEAR () {	0x200;}
}
unless(defined(&DEC_SRC_CONTIGUOUS)) {
    sub DEC_SRC_CONTIGUOUS () {	0x800;}
}
unless(defined(&DEC_MONOCHROME)) {
    sub DEC_MONOCHROME () {	0x1000;}
}
unless(defined(&DEC_SRC_TRANSPARENT)) {
    sub DEC_SRC_TRANSPARENT () {	0x2000;}
}
unless(defined(&DEC_DEPTH_MASK)) {
    sub DEC_DEPTH_MASK () {	0x1c000;}
}
unless(defined(&DEC_DEPTH_SHIFT)) {
    sub DEC_DEPTH_SHIFT () {	14;}
}
unless(defined(&DEC_DST_LINEAR)) {
    sub DEC_DST_LINEAR () {	0x40000;}
}
unless(defined(&DEC_DST_CONTIGUOUS)) {
    sub DEC_DST_CONTIGUOUS () {	0x80000;}
}
unless(defined(&DEC_DST_TRANSPARENT)) {
    sub DEC_DST_TRANSPARENT () {	0x100000;}
}
unless(defined(&DEC_DST_TRANSPARENT_POLARITY)) {
    sub DEC_DST_TRANSPARENT_POLARITY () {	0x200000;}
}
unless(defined(&DEC_PATTERN_MASK)) {
    sub DEC_PATTERN_MASK () {	0xc00000;}
}
unless(defined(&DEC_PATTERN_SHIFT)) {
    sub DEC_PATTERN_SHIFT () {	22;}
}
unless(defined(&DEC_WIDTH_MASK)) {
    sub DEC_WIDTH_MASK () {	0x7000000;}
}
unless(defined(&DEC_WIDTH_SHIFT)) {
    sub DEC_WIDTH_SHIFT () {	24;}
}
unless(defined(&DEC_UPDATE_MASK)) {
    sub DEC_UPDATE_MASK () {	0x18000000;}
}
unless(defined(&DEC_UPDATE_SHIFT)) {
    sub DEC_UPDATE_SHIFT () {	27;}
}
unless(defined(&DEC_START_MASK)) {
    sub DEC_START_MASK () {	0x60000000;}
}
unless(defined(&DEC_START_SHIFT)) {
    sub DEC_START_SHIFT () {	29;}
}
unless(defined(&DEC_START)) {
    sub DEC_START () {	0x80000000;}
}
unless(defined(&DEC_COMMAND_NOP)) {
    sub DEC_COMMAND_NOP () {	0x;}
}
unless(defined(&DEC_COMMAND_BLT)) {
    sub DEC_COMMAND_BLT () {	0x1;}
}
unless(defined(&DEC_COMMAND_RECT)) {
    sub DEC_COMMAND_RECT () {	0x2;}
}
unless(defined(&DEC_COMMAND_BLT_STRETCH)) {
    sub DEC_COMMAND_BLT_STRETCH () {	0x3;}
}
unless(defined(&DEC_COMMAND_STRIP)) {
    sub DEC_COMMAND_STRIP () {	0x4;}
}
unless(defined(&DEC_COMMAND_HOST_BLT)) {
    sub DEC_COMMAND_HOST_BLT () {	0x8;}
}
unless(defined(&DEC_COMMAND_SCREEN_BLT)) {
    sub DEC_COMMAND_SCREEN_BLT () {	0x9;}
}
unless(defined(&DEC_COMMAND_VECT_ENDP)) {
    sub DEC_COMMAND_VECT_ENDP () {	0xc;}
}
unless(defined(&DEC_COMMAND_VECT_NO_ENDP)) {
    sub DEC_COMMAND_VECT_NO_ENDP () {	0xd;}
}
unless(defined(&DEC_DEPTH_8)) {
    sub DEC_DEPTH_8 () {	0x1;}
}
unless(defined(&DEC_DEPTH_16)) {
    sub DEC_DEPTH_16 () {	0x2;}
}
unless(defined(&DEC_DEPTH_32)) {
    sub DEC_DEPTH_32 () {	0x3;}
}
unless(defined(&DEC_DEPTH_24)) {
    sub DEC_DEPTH_24 () {	0x4;}
}
unless(defined(&DEC_WIDTH_LINEAR)) {
    sub DEC_WIDTH_LINEAR () {	0x;}
}
unless(defined(&DEC_WIDTH_640)) {
    sub DEC_WIDTH_640 () {	0x1;}
}
unless(defined(&DEC_WIDTH_800)) {
    sub DEC_WIDTH_800 () {	0x2;}
}
unless(defined(&DEC_WIDTH_1024)) {
    sub DEC_WIDTH_1024 () {	0x4;}
}
unless(defined(&DEC_WIDTH_1152)) {
    sub DEC_WIDTH_1152 () {	0x5;}
}
unless(defined(&DEC_WIDTH_1280)) {
    sub DEC_WIDTH_1280 () {	0x6;}
}
unless(defined(&DEC_WIDTH_1600)) {
    sub DEC_WIDTH_1600 () {	0x7;}
}
unless(defined(&DEC_UPDATE_NONE)) {
    sub DEC_UPDATE_NONE () {	0x;}
}
unless(defined(&DEC_UPDATE_TOP_RIGHT)) {
    sub DEC_UPDATE_TOP_RIGHT () {	0x1;}
}
unless(defined(&DEC_UPDATE_BOTTOM_LEFT)) {
    sub DEC_UPDATE_BOTTOM_LEFT () {	0x2;}
}
unless(defined(&DEC_UPDATE_LASTPIX)) {
    sub DEC_UPDATE_LASTPIX () {	0x3;}
}
unless(defined(&DEC_START_DIMX)) {
    sub DEC_START_DIMX () {	0x1;}
}
unless(defined(&DEC_START_SRC)) {
    sub DEC_START_SRC () {	0x2;}
}
unless(defined(&DEC_START_DST)) {
    sub DEC_START_DST () {	0x3;}
}
unless(defined(&ROP_DST)) {
    sub ROP_DST () {	0x66;}
}
unless(defined(&ROP_SRC)) {
    sub ROP_SRC () {	0xcc;}
}
unless(defined(&ROP_PATTERN)) {
    sub ROP_PATTERN () {	0xf0;}
}
unless(defined(&ATR_PIXEL)) {
    sub ATR_PIXEL () {	0x80;}
}
unless(defined(&PIXEL_DEPTH_MASK)) {
    sub PIXEL_DEPTH_MASK () {	0xf;}
}
unless(defined(&PIXEL_DEPTH_SHIFT)) {
    sub PIXEL_DEPTH_SHIFT () {	0;}
}
unless(defined(&PIXEL_4)) {
    sub PIXEL_4 () {	0x1;}
}
unless(defined(&PIXEL_8)) {
    sub PIXEL_8 () {	0x2;}
}
unless(defined(&PIXEL_15)) {
    sub PIXEL_15 () {	0xc;}
}
unless(defined(&PIXEL_16)) {
    sub PIXEL_16 () {	0xd;}
}
unless(defined(&PIXEL_24)) {
    sub PIXEL_24 () {	0xe;}
}
unless(defined(&PIXEL_32)) {
    sub PIXEL_32 () {	0xf;}
}
unless(defined(&ATR_APERTURE)) {
    sub ATR_APERTURE () {	0xc0;}
}
unless(defined(&ATR_DPMS)) {
    sub ATR_DPMS () {	0xd0;}
}
unless(defined(&DPMS_HSYNC_DISABLE)) {
    sub DPMS_HSYNC_DISABLE () {	0x1;}
}
unless(defined(&DPMS_VSYNC_DISABLE)) {
    sub DPMS_VSYNC_DISABLE () {	0x2;}
}
unless(defined(&ATR_COLOR_CORRECTION)) {
    sub ATR_COLOR_CORRECTION () {	0xe0;}
}
unless(defined(&ATR_MCLK)) {
    sub ATR_MCLK () {	0xe8;}
}
unless(defined(&ATR_PCLK)) {
    sub ATR_PCLK () {	0xec;}
}
unless(defined(&ATR_CURSOR_ENABLE)) {
    sub ATR_CURSOR_ENABLE () {	0x140;}
}
unless(defined(&ATR_CURSOR_FG)) {
    sub ATR_CURSOR_FG () {	0x141;}
}
unless(defined(&ATR_CURSOR_BG)) {
    sub ATR_CURSOR_BG () {	0x142;}
}
unless(defined(&ATR_CURSOR_ADDRESS)) {
    sub ATR_CURSOR_ADDRESS () {	0x144;}
}
unless(defined(&ATR_CURSOR_POSITION)) {
    sub ATR_CURSOR_POSITION () {	0x148;}
}
unless(defined(&ATR_CURSOR_OFFSET)) {
    sub ATR_CURSOR_OFFSET () {	0x14c;}
}
unless(defined(&ATR_ID)) {
    sub ATR_ID () {	0x182;}
}
unless(defined(&ID_AP6422)) {
    sub ID_AP6422 () {	0x6422;}
}
unless(defined(&ID_AT24)) {
    sub ID_AT24 () {	0x6424;}
}
unless(defined(&ID_AT3D)) {
    sub ID_AT3D () {	0x643d;}
}
unless(defined(&ATR_FIFO_STATUS)) {
    sub ATR_FIFO_STATUS () {	0x1fc;}
}
unless(defined(&ATR_BLT_STATUS)) {
    sub ATR_BLT_STATUS () {	0x1fd;}
}
unless(defined(&FIFO_MASK)) {
    sub FIFO_MASK () {	0xf;}
}
unless(defined(&FIFO_SHIFT)) {
    sub FIFO_SHIFT () {	0;}
}
unless(defined(&FIFO_AP6422)) {
    sub FIFO_AP6422 () {	4;}
}
unless(defined(&FIFO_AT24)) {
    sub FIFO_AT24 () {	8;}
}
unless(defined(&BLT_HOST_BUSY)) {
    sub BLT_HOST_BUSY () {	0x1;}
}
unless(defined(&BLT_ENGINE_BUSY)) {
    sub BLT_ENGINE_BUSY () {	0x4;}
}
1;
