require '_h2ph_pre.ph';

no warnings 'redefine';

require 'dev/mii/miivar.ph';
unless(defined(&INTERFACE_NAME_LEN)) {
    sub INTERFACE_NAME_LEN () {	32;}
}
unless(defined(&sc_media)) {
    sub sc_media () {	 ($sc_mii->{mii_media});}
}
unless(defined(&DP8390_VENDOR_UNKNOWN)) {
    sub DP8390_VENDOR_UNKNOWN () {	0xff;}
}
unless(defined(&DP8390_VENDOR_WD_SMC)) {
    sub DP8390_VENDOR_WD_SMC () {	0x;}
}
unless(defined(&DP8390_VENDOR_3COM)) {
    sub DP8390_VENDOR_3COM () {	0x1;}
}
unless(defined(&DP8390_VENDOR_NOVELL)) {
    sub DP8390_VENDOR_NOVELL () {	0x2;}
}
unless(defined(&DP8390_VENDOR_APPLE)) {
    sub DP8390_VENDOR_APPLE () {	0x10;}
}
unless(defined(&DP8390_VENDOR_INTERLAN)) {
    sub DP8390_VENDOR_INTERLAN () {	0x11;}
}
unless(defined(&DP8390_VENDOR_DAYNA)) {
    sub DP8390_VENDOR_DAYNA () {	0x12;}
}
unless(defined(&DP8390_VENDOR_ASANTE)) {
    sub DP8390_VENDOR_ASANTE () {	0x13;}
}
unless(defined(&DP8390_VENDOR_FARALLON)) {
    sub DP8390_VENDOR_FARALLON () {	0x14;}
}
unless(defined(&DP8390_VENDOR_FOCUS)) {
    sub DP8390_VENDOR_FOCUS () {	0x15;}
}
unless(defined(&DP8390_VENDOR_KINETICS)) {
    sub DP8390_VENDOR_KINETICS () {	0x16;}
}
unless(defined(&DP8390_VENDOR_CABLETRON)) {
    sub DP8390_VENDOR_CABLETRON () {	0x17;}
}
unless(defined(&DP8390_DISABLE_TRANSCEIVER)) {
    sub DP8390_DISABLE_TRANSCEIVER () {	0x1;}
}
unless(defined(&DP8390_FORCE_8BIT_MODE)) {
    sub DP8390_FORCE_8BIT_MODE () {	0x2;}
}
unless(defined(&DP8390_FORCE_16BIT_MODE)) {
    sub DP8390_FORCE_16BIT_MODE () {	0x4;}
}
unless(defined(&DP8390_NO_MULTI_BUFFERING)) {
    sub DP8390_NO_MULTI_BUFFERING () {	0x8;}
}
unless(defined(&DP8390_FORCE_PIO)) {
    sub DP8390_FORCE_PIO () {	0x10;}
}
unless(defined(&DP8390_DO_AX88190_WORKAROUND)) {
    sub DP8390_DO_AX88190_WORKAROUND () {	0x20;}
}
unless(defined(&DP8390_ATTACHED)) {
    sub DP8390_ATTACHED () {	0x40;}
}
unless(defined(&DP8390_NO_REMOTE_DMA_COMPLETE)) {
    sub DP8390_NO_REMOTE_DMA_COMPLETE () {	0x80;}
}
unless(defined(&NIC_GET)) {
    sub NIC_GET {
	my($t, $h, $reg) = @_;
	eval q( &bus_space_read_1($t, $h, (( &sc)-> $sc_reg_map[$reg])));
    }
}
unless(defined(&NIC_PUT)) {
    sub NIC_PUT {
	my($t, $h, $reg, $val) = @_;
	eval q( &bus_space_write_1($t, $h, (( &sc)-> $sc_reg_map[$reg]), ($val)));
    }
}
unless(defined(&NIC_BARRIER)) {
    sub NIC_BARRIER {
	my($t, $h) = @_;
	eval q( &bus_space_barrier($t, $h, 0, 0x10,  &BUS_SPACE_BARRIER_READ |  &BUS_SPACE_BARRIER_WRITE));
    }
}
1;
