require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&IHA_MAX_SG_ENTRIES)) {
    sub IHA_MAX_SG_ENTRIES () {	33;}
}
unless(defined(&IHA_MAX_TARGETS)) {
    sub IHA_MAX_TARGETS () {	16;}
}
unless(defined(&IHA_MAX_SCB)) {
    sub IHA_MAX_SCB () {	32;}
}
unless(defined(&IHA_MAX_EXTENDED_MSG)) {
    sub IHA_MAX_EXTENDED_MSG () {	4;}
}
unless(defined(&STATUS_QUEUED)) {
    sub STATUS_QUEUED () {	0;}
}
unless(defined(&STATUS_RENT)) {
    sub STATUS_RENT () {	1;}
}
unless(defined(&STATUS_SELECT)) {
    sub STATUS_SELECT () {	2;}
}
unless(defined(&STATUS_BUSY)) {
    sub STATUS_BUSY () {	3;}
}
unless(defined(&FLAG_RSENS)) {
    sub FLAG_RSENS () {	0x10000;}
}
unless(defined(&FLAG_SG)) {
    sub FLAG_SG () {	0x20000;}
}
unless(defined(&FLAG_DIR)) {
    sub FLAG_DIR () {	( &SCSI_DATA_IN |  &SCSI_DATA_OUT);}
}
unless(defined(&HOST_OK)) {
    sub HOST_OK () {	0x;}
}
unless(defined(&HOST_TIMED_OUT)) {
    sub HOST_TIMED_OUT () {	0x1;}
}
unless(defined(&HOST_SPERR)) {
    sub HOST_SPERR () {	0x10;}
}
unless(defined(&HOST_SEL_TOUT)) {
    sub HOST_SEL_TOUT () {	0x11;}
}
unless(defined(&HOST_DO_DU)) {
    sub HOST_DO_DU () {	0x12;}
}
unless(defined(&HOST_BAD_PHAS)) {
    sub HOST_BAD_PHAS () {	0x14;}
}
unless(defined(&HOST_SCSI_RST)) {
    sub HOST_SCSI_RST () {	0x1b;}
}
unless(defined(&HOST_DEV_RST)) {
    sub HOST_DEV_RST () {	0x1c;}
}
unless(defined(&FLAG_SCSI_RATE)) {
    sub FLAG_SCSI_RATE () {	0x7;}
}
unless(defined(&FLAG_EN_DISC)) {
    sub FLAG_EN_DISC () {	0x8;}
}
unless(defined(&FLAG_NO_SYNC)) {
    sub FLAG_NO_SYNC () {	0x10;}
}
unless(defined(&FLAG_NO_WIDE)) {
    sub FLAG_NO_WIDE () {	0x20;}
}
unless(defined(&FLAG_1GIGA)) {
    sub FLAG_1GIGA () {	0x40;}
}
unless(defined(&FLAG_SPINUP)) {
    sub FLAG_SPINUP () {	0x80;}
}
unless(defined(&FLAG_WIDE_DONE)) {
    sub FLAG_WIDE_DONE () {	0x100;}
}
unless(defined(&FLAG_SYNC_DONE)) {
    sub FLAG_SYNC_DONE () {	0x200;}
}
unless(defined(&FLAG_NO_NEG_SYNC)) {
    sub FLAG_NO_NEG_SYNC () {	( &FLAG_NO_SYNC |  &FLAG_SYNC_DONE);}
}
unless(defined(&FLAG_NO_NEG_WIDE)) {
    sub FLAG_NO_NEG_WIDE () {	( &FLAG_NO_WIDE |  &FLAG_WIDE_DONE);}
}
unless(defined(&PERIOD_WIDE_SCSI)) {
    sub PERIOD_WIDE_SCSI () {	0x80;}
}
unless(defined(&PERIOD_SYXPD)) {
    sub PERIOD_SYXPD () {	0x70;}
}
unless(defined(&PERIOD_SYOFS)) {
    sub PERIOD_SYOFS () {	0xf;}
}
unless(defined(&FLAG_EXPECT_DISC)) {
    sub FLAG_EXPECT_DISC () {	0x1;}
}
unless(defined(&FLAG_EXPECT_SELECT)) {
    sub FLAG_EXPECT_SELECT () {	0x2;}
}
unless(defined(&FLAG_EXPECT_RESET)) {
    sub FLAG_EXPECT_RESET () {	0x10;}
}
unless(defined(&FLAG_EXPECT_DONE_DISC)) {
    sub FLAG_EXPECT_DONE_DISC () {	0x20;}
}
unless(defined(&SEMAPH_IN_MAIN)) {
    sub SEMAPH_IN_MAIN () {	0x;}
}
unless(defined(&PHASE_DATA_OUT)) {
    sub PHASE_DATA_OUT () {	0x;}
}
unless(defined(&PHASE_DATA_IN)) {
    sub PHASE_DATA_IN () {	0x1;}
}
unless(defined(&PHASE_CMD_OUT)) {
    sub PHASE_CMD_OUT () {	0x2;}
}
unless(defined(&PHASE_STATUS_IN)) {
    sub PHASE_STATUS_IN () {	0x3;}
}
unless(defined(&PHASE_MSG_OUT)) {
    sub PHASE_MSG_OUT () {	0x6;}
}
unless(defined(&PHASE_MSG_IN)) {
    sub PHASE_MSG_IN () {	0x7;}
}
unless(defined(&CFG_SCSI_RESET)) {
    sub CFG_SCSI_RESET () {	0x1;}
}
unless(defined(&CFG_EN_PAR)) {
    sub CFG_EN_PAR () {	0x2;}
}
unless(defined(&CFG_ACT_TERM1)) {
    sub CFG_ACT_TERM1 () {	0x4;}
}
unless(defined(&CFG_ACT_TERM2)) {
    sub CFG_ACT_TERM2 () {	0x8;}
}
unless(defined(&CFG_AUTO_TERM)) {
    sub CFG_AUTO_TERM () {	0x10;}
}
unless(defined(&CFG_EN_PWR)) {
    sub CFG_EN_PWR () {	0x80;}
}
unless(defined(&SIGNATURE)) {
    sub SIGNATURE () {	0xc925;}
}
unless(defined(&BIOSCFG_ENABLE)) {
    sub BIOSCFG_ENABLE () {	0x1;}
}
unless(defined(&BIOSCFG_8DRIVE)) {
    sub BIOSCFG_8DRIVE () {	0x2;}
}
unless(defined(&BIOSCFG_REMOVABLE)) {
    sub BIOSCFG_REMOVABLE () {	0x4;}
}
unless(defined(&BIOSCFG_INT19)) {
    sub BIOSCFG_INT19 () {	0x8;}
}
unless(defined(&BIOSCFG_BIOSSCAN)) {
    sub BIOSCFG_BIOSSCAN () {	0x10;}
}
unless(defined(&BIOSCFG_LUNSUPPORT)) {
    sub BIOSCFG_LUNSUPPORT () {	0x40;}
}
unless(defined(&BIOSCFG_DEFAULT)) {
    sub BIOSCFG_DEFAULT () {	( &BIOSCFG_ENABLE);}
}
unless(defined(&HACFG_BOOTIDMASK)) {
    sub HACFG_BOOTIDMASK () {	0xf;}
}
unless(defined(&HACFG_LUNMASK)) {
    sub HACFG_LUNMASK () {	0x70;}
}
unless(defined(&HACFG_CHANMASK)) {
    sub HACFG_CHANMASK () {	0x80;}
}
unless(defined(&TUL_GCTRL0)) {
    sub TUL_GCTRL0 () {	0x54;}
}
unless(defined(&EEPRG)) {
    sub EEPRG () {	0x4;}
}
unless(defined(&TUL_GCTRL1)) {
    sub TUL_GCTRL1 () {	0x55;}
}
unless(defined(&ATDEN)) {
    sub ATDEN () {	0x1;}
}
unless(defined(&TUL_GSTAT)) {
    sub TUL_GSTAT () {	0x56;}
}
unless(defined(&TUL_EPAD0)) {
    sub TUL_EPAD0 () {	0x58;}
}
unless(defined(&TUL_EPAD1)) {
    sub TUL_EPAD1 () {	0x59;}
}
unless(defined(&TUL_PNVPG)) {
    sub TUL_PNVPG () {	0x5a;}
}
unless(defined(&TUL_EPDATA)) {
    sub TUL_EPDATA () {	0x5c;}
}
unless(defined(&TUL_NVRAM)) {
    sub TUL_NVRAM () {	0x5d;}
}
unless(defined(&NVREAD)) {
    sub NVREAD () {	0x80;}
}
unless(defined(&NVWRITE)) {
    sub NVWRITE () {	0x40;}
}
unless(defined(&NVENABLE_ERASE)) {
    sub NVENABLE_ERASE () {	0x30;}
}
unless(defined(&NVRCS)) {
    sub NVRCS () {	0x8;}
}
unless(defined(&NVRCK)) {
    sub NVRCK () {	0x4;}
}
unless(defined(&NVRDO)) {
    sub NVRDO () {	0x2;}
}
unless(defined(&NVRDI)) {
    sub NVRDI () {	0x1;}
}
unless(defined(&TUL_STCNT0)) {
    sub TUL_STCNT0 () {	0x80;}
}
unless(defined(&TCNT)) {
    sub TCNT () {	0xffffff;}
}
unless(defined(&TUL_SFIFOCNT)) {
    sub TUL_SFIFOCNT () {	0x83;}
}
unless(defined(&FIFOC)) {
    sub FIFOC () {	0x1f;}
}
unless(defined(&TUL_SISTAT)) {
    sub TUL_SISTAT () {	0x84;}
}
unless(defined(&RSELED)) {
    sub RSELED () {	0x80;}
}
unless(defined(&STIMEO)) {
    sub STIMEO () {	0x40;}
}
unless(defined(&SBSRV)) {
    sub SBSRV () {	0x20;}
}
unless(defined(&SRSTD)) {
    sub SRSTD () {	0x10;}
}
unless(defined(&DISCD)) {
    sub DISCD () {	0x8;}
}
unless(defined(&SELED)) {
    sub SELED () {	0x4;}
}
unless(defined(&SCAMSCT)) {
    sub SCAMSCT () {	0x2;}
}
unless(defined(&SCMDN)) {
    sub SCMDN () {	0x1;}
}
unless(defined(&TUL_SIEN)) {
    sub TUL_SIEN () {	0x84;}
}
unless(defined(&ALL_INTERRUPTS)) {
    sub ALL_INTERRUPTS () {	0xff;}
}
unless(defined(&TUL_STAT0)) {
    sub TUL_STAT0 () {	0x85;}
}
unless(defined(&INTPD)) {
    sub INTPD () {	0x80;}
}
unless(defined(&SQACT)) {
    sub SQACT () {	0x40;}
}
unless(defined(&XFCZ)) {
    sub XFCZ () {	0x20;}
}
unless(defined(&SFEMP)) {
    sub SFEMP () {	0x10;}
}
unless(defined(&SPERR)) {
    sub SPERR () {	0x8;}
}
unless(defined(&PH_MASK)) {
    sub PH_MASK () {	0x7;}
}
unless(defined(&TUL_SCTRL0)) {
    sub TUL_SCTRL0 () {	0x85;}
}
unless(defined(&RSSQC)) {
    sub RSSQC () {	0x20;}
}
unless(defined(&RSFIFO)) {
    sub RSFIFO () {	0x10;}
}
unless(defined(&CMDAB)) {
    sub CMDAB () {	0x4;}
}
unless(defined(&RSMOD)) {
    sub RSMOD () {	0x2;}
}
unless(defined(&RSCSI)) {
    sub RSCSI () {	0x1;}
}
unless(defined(&TUL_STAT1)) {
    sub TUL_STAT1 () {	0x86;}
}
unless(defined(&STRCV)) {
    sub STRCV () {	0x80;}
}
unless(defined(&MSGST)) {
    sub MSGST () {	0x40;}
}
unless(defined(&CPDNE)) {
    sub CPDNE () {	0x20;}
}
unless(defined(&DPHDN)) {
    sub DPHDN () {	0x10;}
}
unless(defined(&STSNT)) {
    sub STSNT () {	0x8;}
}
unless(defined(&SXCMP)) {
    sub SXCMP () {	0x4;}
}
unless(defined(&SLCMP)) {
    sub SLCMP () {	0x2;}
}
unless(defined(&ARBCMP)) {
    sub ARBCMP () {	0x1;}
}
unless(defined(&TUL_SCTRL1)) {
    sub TUL_SCTRL1 () {	0x86;}
}
unless(defined(&ENSCAM)) {
    sub ENSCAM () {	0x80;}
}
unless(defined(&NIDARB)) {
    sub NIDARB () {	0x40;}
}
unless(defined(&ENLRS)) {
    sub ENLRS () {	0x20;}
}
unless(defined(&PWDN)) {
    sub PWDN () {	0x10;}
}
unless(defined(&WCPU)) {
    sub WCPU () {	0x8;}
}
unless(defined(&EHRSL)) {
    sub EHRSL () {	0x4;}
}
unless(defined(&ESBUSOUT)) {
    sub ESBUSOUT () {	0x2;}
}
unless(defined(&ESBUSIN)) {
    sub ESBUSIN () {	0x1;}
}
unless(defined(&TUL_SSTATUS2)) {
    sub TUL_SSTATUS2 () {	0x87;}
}
unless(defined(&SABRT)) {
    sub SABRT () {	0x80;}
}
unless(defined(&OSCZ)) {
    sub OSCZ () {	0x40;}
}
unless(defined(&SFFUL)) {
    sub SFFUL () {	0x20;}
}
unless(defined(&TMCZ)) {
    sub TMCZ () {	0x10;}
}
unless(defined(&BSYGN)) {
    sub BSYGN () {	0x8;}
}
unless(defined(&PHMIS)) {
    sub PHMIS () {	0x4;}
}
unless(defined(&SBEN)) {
    sub SBEN () {	0x2;}
}
unless(defined(&SRST)) {
    sub SRST () {	0x1;}
}
unless(defined(&TUL_SCONFIG0)) {
    sub TUL_SCONFIG0 () {	0x87;}
}
unless(defined(&PHLAT)) {
    sub PHLAT () {	0x80;}
}
unless(defined(&ITMOD)) {
    sub ITMOD () {	0x40;}
}
unless(defined(&SPCHK)) {
    sub SPCHK () {	0x20;}
}
unless(defined(&ADMA8)) {
    sub ADMA8 () {	0x10;}
}
unless(defined(&ADMAW)) {
    sub ADMAW () {	0x8;}
}
unless(defined(&EDACK)) {
    sub EDACK () {	0x4;}
}
unless(defined(&ALTPD)) {
    sub ALTPD () {	0x2;}
}
unless(defined(&DSRST)) {
    sub DSRST () {	0x1;}
}
unless(defined(&SCONFIG0DEFAULT)) {
    sub SCONFIG0DEFAULT () {	( &PHLAT |  &ITMOD |  &ALTPD |  &DSRST);}
}
unless(defined(&TUL_SOFSC)) {
    sub TUL_SOFSC () {	0x88;}
}
unless(defined(&TUL_SYNCM)) {
    sub TUL_SYNCM () {	0x88;}
}
unless(defined(&TUL_SBID)) {
    sub TUL_SBID () {	0x89;}
}
unless(defined(&TUL_SID)) {
    sub TUL_SID () {	0x89;}
}
unless(defined(&TUL_SALVC)) {
    sub TUL_SALVC () {	0x8a;}
}
unless(defined(&TUL_STIMO)) {
    sub TUL_STIMO () {	0x8a;}
}
unless(defined(&TUL_SDATI)) {
    sub TUL_SDATI () {	0x8b;}
}
unless(defined(&TUL_SDAT0)) {
    sub TUL_SDAT0 () {	0x8b;}
}
unless(defined(&TUL_SFIFO)) {
    sub TUL_SFIFO () {	0x8c;}
}
unless(defined(&TUL_SSIGI)) {
    sub TUL_SSIGI () {	0x90;}
}
unless(defined(&REQ)) {
    sub REQ () {	0x80;}
}
unless(defined(&ACK)) {
    sub ACK () {	0x40;}
}
unless(defined(&BSY)) {
    sub BSY () {	0x20;}
}
unless(defined(&SEL)) {
    sub SEL () {	0x10;}
}
unless(defined(&ATN)) {
    sub ATN () {	0x8;}
}
unless(defined(&MSG)) {
    sub MSG () {	0x4;}
}
unless(defined(&CD)) {
    sub CD () {	0x2;}
}
unless(defined(&IO)) {
    sub IO () {	0x1;}
}
unless(defined(&TUL_SSIGO)) {
    sub TUL_SSIGO () {	0x90;}
}
unless(defined(&TUL_SCMD)) {
    sub TUL_SCMD () {	0x91;}
}
unless(defined(&NO_OP)) {
    sub NO_OP () {	0x;}
}
unless(defined(&SEL_NOATN)) {
    sub SEL_NOATN () {	0x1;}
}
unless(defined(&XF_FIFO_OUT)) {
    sub XF_FIFO_OUT () {	0x3;}
}
unless(defined(&MSG_ACCEPT)) {
    sub MSG_ACCEPT () {	0xf;}
}
unless(defined(&SEL_ATN)) {
    sub SEL_ATN () {	0x11;}
}
unless(defined(&SEL_ATNSTOP)) {
    sub SEL_ATNSTOP () {	0x12;}
}
unless(defined(&SELATNSTOP)) {
    sub SELATNSTOP () {	0x1e;}
}
unless(defined(&SEL_ATN3)) {
    sub SEL_ATN3 () {	0x31;}
}
unless(defined(&XF_DMA_OUT)) {
    sub XF_DMA_OUT () {	0x43;}
}
unless(defined(&EN_RESEL)) {
    sub EN_RESEL () {	0x80;}
}
unless(defined(&XF_FIFO_IN)) {
    sub XF_FIFO_IN () {	0x83;}
}
unless(defined(&CMD_COMP)) {
    sub CMD_COMP () {	0x84;}
}
unless(defined(&XF_DMA_IN)) {
    sub XF_DMA_IN () {	0xc3;}
}
unless(defined(&TUL_STEST0)) {
    sub TUL_STEST0 () {	0x92;}
}
unless(defined(&TUL_STEST1)) {
    sub TUL_STEST1 () {	0x93;}
}
unless(defined(&TUL_DXPA)) {
    sub TUL_DXPA () {	0xc0;}
}
unless(defined(&TUL_DXPAE)) {
    sub TUL_DXPAE () {	0xc4;}
}
unless(defined(&TUL_DCXA)) {
    sub TUL_DCXA () {	0xc8;}
}
unless(defined(&TUL_DCXAE)) {
    sub TUL_DCXAE () {	0xcc;}
}
unless(defined(&TUL_DXC)) {
    sub TUL_DXC () {	0xd0;}
}
unless(defined(&TUL_DCXC)) {
    sub TUL_DCXC () {	0xd4;}
}
unless(defined(&TUL_DCMD)) {
    sub TUL_DCMD () {	0xd8;}
}
unless(defined(&SGXFR)) {
    sub SGXFR () {	0x80;}
}
unless(defined(&RSVD)) {
    sub RSVD () {	0x40;}
}
unless(defined(&XDIR)) {
    sub XDIR () {	0x20;}
}
unless(defined(&BMTST)) {
    sub BMTST () {	0x10;}
}
unless(defined(&CLFIFO)) {
    sub CLFIFO () {	0x8;}
}
unless(defined(&ABTXFR)) {
    sub ABTXFR () {	0x4;}
}
unless(defined(&FRXFR)) {
    sub FRXFR () {	0x2;}
}
unless(defined(&STRXFR)) {
    sub STRXFR () {	0x1;}
}
unless(defined(&ST_X_IN)) {
    sub ST_X_IN () {	( &XDIR |  &STRXFR);}
}
unless(defined(&ST_X_OUT)) {
    sub ST_X_OUT () {	(  &STRXFR);}
}
unless(defined(&ST_SG_IN)) {
    sub ST_SG_IN () {	( &SGXFR |  &ST_X_IN);}
}
unless(defined(&ST_SG_OUT)) {
    sub ST_SG_OUT () {	( &SGXFR |  &ST_X_OUT);}
}
unless(defined(&TUL_ISTUS0)) {
    sub TUL_ISTUS0 () {	0xdc;}
}
unless(defined(&DGINT)) {
    sub DGINT () {	0x80;}
}
unless(defined(&RSVRD0)) {
    sub RSVRD0 () {	0x40;}
}
unless(defined(&RSVRD1)) {
    sub RSVRD1 () {	0x20;}
}
unless(defined(&SCMP)) {
    sub SCMP () {	0x10;}
}
unless(defined(&PXERR)) {
    sub PXERR () {	0x8;}
}
unless(defined(&DABT)) {
    sub DABT () {	0x4;}
}
unless(defined(&FXCMP)) {
    sub FXCMP () {	0x2;}
}
unless(defined(&XCMP)) {
    sub XCMP () {	0x1;}
}
unless(defined(&TUL_ISTUS1)) {
    sub TUL_ISTUS1 () {	0xdd;}
}
unless(defined(&SCBSY)) {
    sub SCBSY () {	0x8;}
}
unless(defined(&FFULL)) {
    sub FFULL () {	0x4;}
}
unless(defined(&FEMPT)) {
    sub FEMPT () {	0x2;}
}
unless(defined(&XPEND)) {
    sub XPEND () {	0x1;}
}
unless(defined(&TUL_IMSK)) {
    sub TUL_IMSK () {	0xe0;}
}
unless(defined(&MSCMP)) {
    sub MSCMP () {	0x10;}
}
unless(defined(&MPXFER)) {
    sub MPXFER () {	0x8;}
}
unless(defined(&MDABT)) {
    sub MDABT () {	0x4;}
}
unless(defined(&MFCMP)) {
    sub MFCMP () {	0x2;}
}
unless(defined(&MXCMP)) {
    sub MXCMP () {	0x1;}
}
unless(defined(&MASK_ALL)) {
    sub MASK_ALL () {	( &MXCMP |  &MFCMP |  &MDABT |  &MPXFER |  &MSCMP);}
}
unless(defined(&TUL_DCTRL0)) {
    sub TUL_DCTRL0 () {	0xe4;}
}
unless(defined(&SXSTP)) {
    sub SXSTP () {	0x80;}
}
unless(defined(&RPMOD)) {
    sub RPMOD () {	0x40;}
}
unless(defined(&RSVRD2)) {
    sub RSVRD2 () {	0x20;}
}
unless(defined(&PWDWN)) {
    sub PWDWN () {	0x10;}
}
unless(defined(&ENTM)) {
    sub ENTM () {	0x8;}
}
unless(defined(&ENTMW)) {
    sub ENTMW () {	0x4;}
}
unless(defined(&DISAFC)) {
    sub DISAFC () {	0x2;}
}
unless(defined(&LEDCTL)) {
    sub LEDCTL () {	0x1;}
}
unless(defined(&TUL_DCTRL1)) {
    sub TUL_DCTRL1 () {	0xe5;}
}
unless(defined(&SDWS)) {
    sub SDWS () {	0x1;}
}
unless(defined(&TUL_DFIFO)) {
    sub TUL_DFIFO () {	0xe8;}
}
unless(defined(&TUL_WCTRL)) {
    sub TUL_WCTRL () {	0xf7;}
}
unless(defined(&TUL_DCTRL)) {
    sub TUL_DCTRL () {	0xfb;}
}
1;
