require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&M_msf)) {
    sub M_msf {
	my($msf) = @_;
	eval q($msf->[0]);
    }
}
unless(defined(&S_msf)) {
    sub S_msf {
	my($msf) = @_;
	eval q($msf->[1]);
    }
}
unless(defined(&F_msf)) {
    sub F_msf {
	my($msf) = @_;
	eval q($msf->[2]);
    }
}
unless(defined(&MCD_COMMAND)) {
    sub MCD_COMMAND () {	0;}
}
unless(defined(&MCD_STATUS)) {
    sub MCD_STATUS () {	0;}
}
unless(defined(&MCD_RDATA)) {
    sub MCD_RDATA () {	0;}
}
unless(defined(&MCD_RESET)) {
    sub MCD_RESET () {	1;}
}
unless(defined(&MCD_XFER)) {
    sub MCD_XFER () {	1;}
}
unless(defined(&MCD_CTL2)) {
    sub MCD_CTL2 () {	2;}
}
unless(defined(&MCD_CONFIG)) {
    sub MCD_CONFIG () {	3;}
}
unless(defined(&MCD_NPORT)) {
    sub MCD_NPORT () {	4;}
}
unless(defined(&MCD_MASK_DMA)) {
    sub MCD_MASK_DMA () {	0x7;}
}
unless(defined(&MCD_MASK_IRQ)) {
    sub MCD_MASK_IRQ () {	0x70;}
}
unless(defined(&MCD_ST_DOOROPEN)) {
    sub MCD_ST_DOOROPEN () {	0x80;}
}
unless(defined(&MCD_ST_DSKIN)) {
    sub MCD_ST_DSKIN () {	0x40;}
}
unless(defined(&MCD_ST_DSKCHNG)) {
    sub MCD_ST_DSKCHNG () {	0x20;}
}
unless(defined(&MCD_ST_SPINNING)) {
    sub MCD_ST_SPINNING () {	0x10;}
}
unless(defined(&MCD_ST_AUDIODISK)) {
    sub MCD_ST_AUDIODISK () {	0x8;}
}
unless(defined(&MCD_ST_READERR)) {
    sub MCD_ST_READERR () {	0x4;}
}
unless(defined(&MCD_ST_AUDIOBSY)) {
    sub MCD_ST_AUDIOBSY () {	0x2;}
}
unless(defined(&MCD_ST_CMDCHECK)) {
    sub MCD_ST_CMDCHECK () {	0x1;}
}
unless(defined(&MCD_XF_STATUSUNAVAIL)) {
    sub MCD_XF_STATUSUNAVAIL () {	0x4;}
}
unless(defined(&MCD_XF_DATAUNAVAIL)) {
    sub MCD_XF_DATAUNAVAIL () {	0x2;}
}
unless(defined(&MCD_MD_TESTMODE)) {
    sub MCD_MD_TESTMODE () {	0x80;}
}
unless(defined(&MCD_MD_DATALENGTH)) {
    sub MCD_MD_DATALENGTH () {	0x40;}
}
unless(defined(&MCD_MD_ECCMODE)) {
    sub MCD_MD_ECCMODE () {	0x20;}
}
unless(defined(&MCD_MD_SPINDOWN)) {
    sub MCD_MD_SPINDOWN () {	0x8;}
}
unless(defined(&MCD_MD_READTOC)) {
    sub MCD_MD_READTOC () {	0x4;}
}
unless(defined(&MCD_MD_PLAYAUDIO)) {
    sub MCD_MD_PLAYAUDIO () {	0x1;}
}
unless(defined(&MCD_MD_RAW)) {
    sub MCD_MD_RAW () {	( &MCD_MD_PLAYAUDIO| &MCD_MD_ECCMODE| &MCD_MD_DATALENGTH);}
}
unless(defined(&MCD_MD_COOKED)) {
    sub MCD_MD_COOKED () {	( &MCD_MD_PLAYAUDIO);}
}
unless(defined(&MCD_MD_TOC)) {
    sub MCD_MD_TOC () {	( &MCD_MD_PLAYAUDIO| &MCD_MD_READTOC);}
}
unless(defined(&MCD_MD_SLEEP)) {
    sub MCD_MD_SLEEP () {	( &MCD_MD_PLAYAUDIO| &MCD_MD_SPINDOWN);}
}
unless(defined(&MCD_BLKSIZE_RAW)) {
    sub MCD_BLKSIZE_RAW () {	$sizeof{'struct mcd_rawsector'};}
}
unless(defined(&MCD_BLKSIZE_COOKED)) {
    sub MCD_BLKSIZE_COOKED () {	2048;}
}
unless(defined(&MCD_LK_UNLOCK)) {
    sub MCD_LK_UNLOCK () {	0x;}
}
unless(defined(&MCD_LK_LOCK)) {
    sub MCD_LK_LOCK () {	0x1;}
}
unless(defined(&MCD_LK_TEST)) {
    sub MCD_LK_TEST () {	0x2;}
}
unless(defined(&MCD_CF_IRQENABLE)) {
    sub MCD_CF_IRQENABLE () {	0x10;}
}
unless(defined(&MCD_CF_DMATIMEOUT)) {
    sub MCD_CF_DMATIMEOUT () {	0x8;}
}
unless(defined(&MCD_CF_READUPC)) {
    sub MCD_CF_READUPC () {	0x4;}
}
unless(defined(&MCD_CF_DMAENABLE)) {
    sub MCD_CF_DMAENABLE () {	0x2;}
}
unless(defined(&MCD_CF_BLOCKSIZE)) {
    sub MCD_CF_BLOCKSIZE () {	0x1;}
}
unless(defined(&MCD_UPC_DISABLE)) {
    sub MCD_UPC_DISABLE () {	0x;}
}
unless(defined(&MCD_UPC_ENABLE)) {
    sub MCD_UPC_ENABLE () {	0x1;}
}
unless(defined(&MCD_CMDRESET)) {
    sub MCD_CMDRESET () {	0x;}
}
unless(defined(&MCD_CMDGETVOLINFO)) {
    sub MCD_CMDGETVOLINFO () {	0x10;}
}
unless(defined(&MCD_CMDGETDISKINFO)) {
    sub MCD_CMDGETDISKINFO () {	0x11;}
}
unless(defined(&MCD_CMDGETQCHN)) {
    sub MCD_CMDGETQCHN () {	0x20;}
}
unless(defined(&MCD_CMDGETSENSE)) {
    sub MCD_CMDGETSENSE () {	0x30;}
}
unless(defined(&MCD_CMDGETSTAT)) {
    sub MCD_CMDGETSTAT () {	0x40;}
}
unless(defined(&MCD_CMDSETMODE)) {
    sub MCD_CMDSETMODE () {	0x50;}
}
unless(defined(&MCD_CMDSTOPAUDIO)) {
    sub MCD_CMDSTOPAUDIO () {	0x70;}
}
unless(defined(&MCD_CMDSTOPAUDIOTIME)) {
    sub MCD_CMDSTOPAUDIOTIME () {	0x80;}
}
unless(defined(&MCD_CMDGETVOLUME)) {
    sub MCD_CMDGETVOLUME () {	0x8e;}
}
unless(defined(&MCD_CMDCONFIGDRIVE)) {
    sub MCD_CMDCONFIGDRIVE () {	0x90;}
}
unless(defined(&MCD_CMDSETDRIVEMODE)) {
    sub MCD_CMDSETDRIVEMODE () {	0xa0;}
}
unless(defined(&MCD_CMDSETVOLUME)) {
    sub MCD_CMDSETVOLUME () {	0xae;}
}
unless(defined(&MCD_CMDREAD1)) {
    sub MCD_CMDREAD1 () {	0xb0;}
}
unless(defined(&MCD_CMDREADSINGLESPEED)) {
    sub MCD_CMDREADSINGLESPEED () {	0xc0;}
}
unless(defined(&MCD_CMDREADDOUBLESPEED)) {
    sub MCD_CMDREADDOUBLESPEED () {	0xc1;}
}
unless(defined(&MCD_CMDGETDRIVEMODE)) {
    sub MCD_CMDGETDRIVEMODE () {	0xc2;}
}
unless(defined(&MCD_CMDREAD3)) {
    sub MCD_CMDREAD3 () {	0xc3;}
}
unless(defined(&MCD_CMDSETINTERLEAVE)) {
    sub MCD_CMDSETINTERLEAVE () {	0xc8;}
}
unless(defined(&MCD_CMDCONTINFO)) {
    sub MCD_CMDCONTINFO () {	0xdc;}
}
unless(defined(&MCD_CMDSTOP)) {
    sub MCD_CMDSTOP () {	0xf0;}
}
unless(defined(&MCD_CMDEJECTDISK)) {
    sub MCD_CMDEJECTDISK () {	0xf6;}
}
unless(defined(&MCD_CMDCLOSETRAY)) {
    sub MCD_CMDCLOSETRAY () {	0xf8;}
}
unless(defined(&MCD_CMDSETLOCK)) {
    sub MCD_CMDSETLOCK () {	0xfe;}
}
1;
