require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&PSS_BASE_VALID)) {
    sub PSS_BASE_VALID {
	my($base) = @_;
	eval q((($base) == 0x220 || ($base) == 0x240));
    }
}
unless(defined(&ADDR_MASK)) {
    sub ADDR_MASK () {	0x3f;}
}
unless(defined(&INT_MASK)) {
    sub INT_MASK () {	0xffc7;}
}
unless(defined(&INT_3_BITS)) {
    sub INT_3_BITS () {	0x8;}
}
unless(defined(&INT_5_BITS)) {
    sub INT_5_BITS () {	0x10;}
}
unless(defined(&INT_7_BITS)) {
    sub INT_7_BITS () {	0x18;}
}
unless(defined(&INT_9_BITS)) {
    sub INT_9_BITS () {	0x20;}
}
unless(defined(&INT_10_BITS)) {
    sub INT_10_BITS () {	0x28;}
}
unless(defined(&INT_11_BITS)) {
    sub INT_11_BITS () {	0x30;}
}
unless(defined(&INT_12_BITS)) {
    sub INT_12_BITS () {	0x38;}
}
unless(defined(&INT_TEST_BIT)) {
    sub INT_TEST_BIT () {	0x200;}
}
unless(defined(&INT_TEST_PASS)) {
    sub INT_TEST_PASS () {	0x100;}
}
unless(defined(&INT_TEST_BIT_MASK)) {
    sub INT_TEST_BIT_MASK () {	0xfdff;}
}
unless(defined(&DMA_MASK)) {
    sub DMA_MASK () {	0xfff8;}
}
unless(defined(&DMA_0_BITS)) {
    sub DMA_0_BITS () {	0x1;}
}
unless(defined(&DMA_1_BITS)) {
    sub DMA_1_BITS () {	0x2;}
}
unless(defined(&DMA_3_BITS)) {
    sub DMA_3_BITS () {	0x3;}
}
unless(defined(&DMA_5_BITS)) {
    sub DMA_5_BITS () {	0x4;}
}
unless(defined(&DMA_6_BITS)) {
    sub DMA_6_BITS () {	0x5;}
}
unless(defined(&DMA_7_BITS)) {
    sub DMA_7_BITS () {	0x6;}
}
unless(defined(&DMA_TEST_BIT)) {
    sub DMA_TEST_BIT () {	0x80;}
}
unless(defined(&DMA_TEST_PASS)) {
    sub DMA_TEST_PASS () {	0x40;}
}
unless(defined(&DMA_TEST_BIT_MASK)) {
    sub DMA_TEST_BIT_MASK () {	0xff7f;}
}
unless(defined(&DSP_FLAG3)) {
    sub DSP_FLAG3 () {	0x10;}
}
unless(defined(&DSP_FLAG2)) {
    sub DSP_FLAG2 () {	0x8;}
}
unless(defined(&DSP_FLAG1)) {
    sub DSP_FLAG1 () {	0x80;}
}
unless(defined(&DSP_FLAG0)) {
    sub DSP_FLAG0 () {	0x40;}
}
unless(defined(&PSS_NPORT)) {
    sub PSS_NPORT () {	32;}
}
unless(defined(&PSS_DATA)) {
    sub PSS_DATA () {	0x;}
}
unless(defined(&PSS_STATUS)) {
    sub PSS_STATUS () {	0x2;}
}
unless(defined(&PSS_CONTROL)) {
    sub PSS_CONTROL () {	0x2;}
}
unless(defined(&PSS_ID_VERS)) {
    sub PSS_ID_VERS () {	0x4;}
}
unless(defined(&PSS_IRQ_ACK)) {
    sub PSS_IRQ_ACK () {	0x4;}
}
unless(defined(&PSS_CONFIG)) {
    sub PSS_CONFIG () {	0x10;}
}
unless(defined(&PSS_WSS_CONFIG)) {
    sub PSS_WSS_CONFIG () {	0x12;}
}
unless(defined(&SB_CONFIG)) {
    sub SB_CONFIG () {	0x14;}
}
unless(defined(&CD_CONFIG)) {
    sub CD_CONFIG () {	0x16;}
}
unless(defined(&MIDI_CONFIG)) {
    sub MIDI_CONFIG () {	0x18;}
}
unless(defined(&UART_CONFIG)) {
    sub UART_CONFIG () {	0x1a;}
}
unless(defined(&PSS_WEIE)) {
    sub PSS_WEIE () {	0x8000;}
}
unless(defined(&PSS_RFIE)) {
    sub PSS_RFIE () {	0x4000;}
}
unless(defined(&PSS_RESET)) {
    sub PSS_RESET () {	0x2000;}
}
unless(defined(&PSS_FLAG1)) {
    sub PSS_FLAG1 () {	0x1000;}
}
unless(defined(&PSS_FLAG0)) {
    sub PSS_FLAG0 () {	0x800;}
}
unless(defined(&PSS_WRITE_EMPTY)) {
    sub PSS_WRITE_EMPTY () {	0x8000;}
}
unless(defined(&PSS_READ_FULL)) {
    sub PSS_READ_FULL () {	0x4000;}
}
unless(defined(&PSS_IRQ)) {
    sub PSS_IRQ () {	0x2000;}
}
unless(defined(&PSS_DMQ_TC)) {
    sub PSS_DMQ_TC () {	0x1000;}
}
unless(defined(&PSS_FLAG3)) {
    sub PSS_FLAG3 () {	0x800;}
}
unless(defined(&PSS_FLAG2)) {
    sub PSS_FLAG2 () {	0x400;}
}
unless(defined(&GAME_BIT)) {
    sub GAME_BIT () {	0x400;}
}
unless(defined(&GAME_BIT_MASK)) {
    sub GAME_BIT_MASK () {	0xfbff;}
}
unless(defined(&MIDI_NPORT)) {
    sub MIDI_NPORT () {	8;}
}
unless(defined(&MIDI_DATA_REG)) {
    sub MIDI_DATA_REG () {	0x;}
}
unless(defined(&MIDI_STATUS_REG)) {
    sub MIDI_STATUS_REG () {	0x1;}
}
unless(defined(&MIDI_COMMAND_REG)) {
    sub MIDI_COMMAND_REG () {	0x1;}
}
unless(defined(&MIDI_SR_RF)) {
    sub MIDI_SR_RF () {	0x80;}
}
unless(defined(&MIDI_SR_TE)) {
    sub MIDI_SR_TE () {	0x40;}
}
unless(defined(&CD_NPORT)) {
    sub CD_NPORT () {	16;}
}
unless(defined(&CD_POL_MASK)) {
    sub CD_POL_MASK () {	0xffbf;}
}
unless(defined(&CD_POL_BIT)) {
    sub CD_POL_BIT () {	0x40;}
}
unless(defined(&SET_MASTER_COMMAND)) {
    sub SET_MASTER_COMMAND () {	0x10;}
}
unless(defined(&MASTER_VOLUME_LEFT)) {
    sub MASTER_VOLUME_LEFT () {	0x;}
}
unless(defined(&MASTER_VOLUME_RIGHT)) {
    sub MASTER_VOLUME_RIGHT () {	0x100;}
}
unless(defined(&MASTER_BASS)) {
    sub MASTER_BASS () {	0x200;}
}
unless(defined(&MASTER_TREBLE)) {
    sub MASTER_TREBLE () {	0x300;}
}
unless(defined(&MASTER_SWITCH)) {
    sub MASTER_SWITCH () {	0x800;}
}
unless(defined(&PSS_STEREO)) {
    sub PSS_STEREO () {	0xce;}
}
unless(defined(&PSS_PSEUDO)) {
    sub PSS_PSEUDO () {	0xd6;}
}
unless(defined(&PSS_SPATIAL)) {
    sub PSS_SPATIAL () {	0xde;}
}
unless(defined(&PSS_MONO)) {
    sub PSS_MONO () {	0xc6;}
}
unless(defined(&PHILLIPS_VOL_MIN)) {
    sub PHILLIPS_VOL_MIN () {	-64;}
}
unless(defined(&PHILLIPS_VOL_MAX)) {
    sub PHILLIPS_VOL_MAX () {	6;}
}
unless(defined(&PHILLIPS_VOL_DELTA)) {
    sub PHILLIPS_VOL_DELTA () {	70;}
}
unless(defined(&PHILLIPS_VOL_INITIAL)) {
    sub PHILLIPS_VOL_INITIAL () {	-20;}
}
unless(defined(&PHILLIPS_VOL_CONSTANT)) {
    sub PHILLIPS_VOL_CONSTANT () {	252;}
}
unless(defined(&PHILLIPS_VOL_STEP)) {
    sub PHILLIPS_VOL_STEP () {	2;}
}
unless(defined(&PHILLIPS_BASS_MIN)) {
    sub PHILLIPS_BASS_MIN () {	-12;}
}
unless(defined(&PHILLIPS_BASS_MAX)) {
    sub PHILLIPS_BASS_MAX () {	15;}
}
unless(defined(&PHILLIPS_BASS_DELTA)) {
    sub PHILLIPS_BASS_DELTA () {	27;}
}
unless(defined(&PHILLIPS_BASS_INITIAL)) {
    sub PHILLIPS_BASS_INITIAL () {	0;}
}
unless(defined(&PHILLIPS_BASS_CONSTANT)) {
    sub PHILLIPS_BASS_CONSTANT () {	246;}
}
unless(defined(&PHILLIPS_BASS_STEP)) {
    sub PHILLIPS_BASS_STEP () {	2;}
}
unless(defined(&PHILLIPS_TREBLE_MIN)) {
    sub PHILLIPS_TREBLE_MIN () {	-12;}
}
unless(defined(&PHILLIPS_TREBLE_MAX)) {
    sub PHILLIPS_TREBLE_MAX () {	12;}
}
unless(defined(&PHILLIPS_TREBLE_DELTA)) {
    sub PHILLIPS_TREBLE_DELTA () {	24;}
}
unless(defined(&PHILLIPS_TREBLE_INITIAL)) {
    sub PHILLIPS_TREBLE_INITIAL () {	0;}
}
unless(defined(&PHILLIPS_TREBLE_CONSTANT)) {
    sub PHILLIPS_TREBLE_CONSTANT () {	246;}
}
unless(defined(&PHILLIPS_TREBLE_STEP)) {
    sub PHILLIPS_TREBLE_STEP () {	2;}
}
1;
