require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&CNW_IO_SIZE)) {
    sub CNW_IO_SIZE () {	0x10;}
}
unless(defined(&CNW_REG_COR)) {
    sub CNW_REG_COR () {	0x;}
}
unless(defined(&CNW_COR_IENA)) {
    sub CNW_COR_IENA () {	0x1;}
}
unless(defined(&CNW_COR_LVLREQ)) {
    sub CNW_COR_LVLREQ () {	0x40;}
}
unless(defined(&CNW_REG_CCSR)) {
    sub CNW_REG_CCSR () {	0x2;}
}
unless(defined(&CNW_REG_ASR)) {
    sub CNW_REG_ASR () {	0x4;}
}
unless(defined(&CNW_ASR_TXBA)) {
    sub CNW_ASR_TXBA () {	0x1;}
}
unless(defined(&CNW_ASR_WOC)) {
    sub CNW_ASR_WOC () {	0x8;}
}
unless(defined(&CNW_ASR_TXDN)) {
    sub CNW_ASR_TXDN () {	0x20;}
}
unless(defined(&CNW_ASR_RXERR)) {
    sub CNW_ASR_RXERR () {	0x40;}
}
unless(defined(&CNW_ASR_RXRDY)) {
    sub CNW_ASR_RXRDY () {	0x80;}
}
unless(defined(&CNW_REG_IOLOW)) {
    sub CNW_REG_IOLOW () {	0x6;}
}
unless(defined(&CNW_REG_IOHI)) {
    sub CNW_REG_IOHI () {	0x7;}
}
unless(defined(&CNW_REG_IOCONTROL)) {
    sub CNW_REG_IOCONTROL () {	0x8;}
}
unless(defined(&CNW_REG_IMR)) {
    sub CNW_REG_IMR () {	0xa;}
}
unless(defined(&CNW_IMR_IENA)) {
    sub CNW_IMR_IENA () {	0x2;}
}
unless(defined(&CNW_IMR_RFU1)) {
    sub CNW_IMR_RFU1 () {	0x10;}
}
unless(defined(&CNW_REG_PMR)) {
    sub CNW_REG_PMR () {	0xc;}
}
unless(defined(&CNW_PMR_RESET)) {
    sub CNW_PMR_RESET () {	0x80;}
}
unless(defined(&CNW_REG_DATA)) {
    sub CNW_REG_DATA () {	0xf;}
}
unless(defined(&CNW_MEM_ADDR)) {
    sub CNW_MEM_ADDR () {	0x20000;}
}
unless(defined(&CNW_MEM_SIZE)) {
    sub CNW_MEM_SIZE () {	0x8000;}
}
unless(defined(&CNW_EREG_CB)) {
    sub CNW_EREG_CB () {	0x100;}
}
unless(defined(&CNW_EREG_ASCC)) {
    sub CNW_EREG_ASCC () {	0x114;}
}
unless(defined(&CNW_EREG_RSER)) {
    sub CNW_EREG_RSER () {	0x120;}
}
unless(defined(&CNW_RSER_RXBIG)) {
    sub CNW_RSER_RXBIG () {	0x2;}
}
unless(defined(&CNW_RSER_RXCRC)) {
    sub CNW_RSER_RXCRC () {	0x4;}
}
unless(defined(&CNW_RSER_RXOVERRUN)) {
    sub CNW_RSER_RXOVERRUN () {	0x8;}
}
unless(defined(&CNW_RSER_RXOVERFLOW)) {
    sub CNW_RSER_RXOVERFLOW () {	0x10;}
}
unless(defined(&CNW_RSER_RXERR)) {
    sub CNW_RSER_RXERR () {	0x40;}
}
unless(defined(&CNW_RSER_RXAVAIL)) {
    sub CNW_RSER_RXAVAIL () {	0x80;}
}
unless(defined(&CNW_EREG_RSERW)) {
    sub CNW_EREG_RSERW () {	0x124;}
}
unless(defined(&CNW_EREG_TSER)) {
    sub CNW_EREG_TSER () {	0x130;}
}
unless(defined(&CNW_TSER_RTRY)) {
    sub CNW_TSER_RTRY () {	0xf;}
}
unless(defined(&CNW_TSER_TXERR)) {
    sub CNW_TSER_TXERR () {	0x10;}
}
unless(defined(&CNW_TSER_TXOK)) {
    sub CNW_TSER_TXOK () {	0x20;}
}
unless(defined(&CNW_TSER_TXNOAP)) {
    sub CNW_TSER_TXNOAP () {	0x40;}
}
unless(defined(&CNW_TSER_TXGU)) {
    sub CNW_TSER_TXGU () {	0x80;}
}
unless(defined(&CNW_TSER_ERROR)) {
    sub CNW_TSER_ERROR () {	( &CNW_TSER_TXERR |  &CNW_TSER_TXNOAP |  &CNW_TSER_TXGU);}
}
unless(defined(&CNW_EREG_TSERW)) {
    sub CNW_EREG_TSERW () {	0x134;}
}
unless(defined(&CNW_EREG_TDP)) {
    sub CNW_EREG_TDP () {	0x140;}
}
unless(defined(&CNW_EREG_LIF)) {
    sub CNW_EREG_LIF () {	0x14e;}
}
unless(defined(&CNW_EREG_RDP)) {
    sub CNW_EREG_RDP () {	0x150;}
}
unless(defined(&CNW_EREG_SPCQ)) {
    sub CNW_EREG_SPCQ () {	0x154;}
}
unless(defined(&CNW_EREG_SPU)) {
    sub CNW_EREG_SPU () {	0x155;}
}
unless(defined(&CNW_EREG_ISPLQ)) {
    sub CNW_EREG_ISPLQ () {	0x156;}
}
unless(defined(&CNW_EREG_HHC)) {
    sub CNW_EREG_HHC () {	0x158;}
}
unless(defined(&CNW_EREG_PA)) {
    sub CNW_EREG_PA () {	0x160;}
}
unless(defined(&CNW_EREG_ARW)) {
    sub CNW_EREG_ARW () {	0x166;}
}
unless(defined(&CNW_EREG_MHS)) {
    sub CNW_EREG_MHS () {	0x16b;}
}
unless(defined(&CNW_EREG_NI)) {
    sub CNW_EREG_NI () {	0x16e;}
}
unless(defined(&CNW_EREG_CRBP)) {
    sub CNW_EREG_CRBP () {	0x17a;}
}
unless(defined(&CNW_EREG_EC)) {
    sub CNW_EREG_EC () {	0x180;}
}
unless(defined(&CNW_EREG_STAT_RXERR)) {
    sub CNW_EREG_STAT_RXERR () {	0x184;}
}
unless(defined(&CNW_EREG_STAT_FRAME)) {
    sub CNW_EREG_STAT_FRAME () {	0x186;}
}
unless(defined(&CNW_EREG_STAT_IBEAT)) {
    sub CNW_EREG_STAT_IBEAT () {	0x188;}
}
unless(defined(&CNW_EREG_STAT_RXBUF)) {
    sub CNW_EREG_STAT_RXBUF () {	0x18e;}
}
unless(defined(&CNW_EREG_STAT_RXMULTI)) {
    sub CNW_EREG_STAT_RXMULTI () {	0x190;}
}
unless(defined(&CNW_EREG_STAT_TXRETRY)) {
    sub CNW_EREG_STAT_TXRETRY () {	0x192;}
}
unless(defined(&CNW_EREG_STAT_TXABORT)) {
    sub CNW_EREG_STAT_TXABORT () {	0x194;}
}
unless(defined(&CNW_EREG_STAT_OBEAT)) {
    sub CNW_EREG_STAT_OBEAT () {	0x198;}
}
unless(defined(&CNW_EREG_STAT_TXOK)) {
    sub CNW_EREG_STAT_TXOK () {	0x19a;}
}
unless(defined(&CNW_EREG_STAT_TXSENT)) {
    sub CNW_EREG_STAT_TXSENT () {	0x19c;}
}
unless(defined(&CNW_CMD_NOP)) {
    sub CNW_CMD_NOP () {	0x;}
}
unless(defined(&CNW_CMD_SRC)) {
    sub CNW_CMD_SRC () {	0x1;}
}
unless(defined(&CNW_RXCONF_RXENA)) {
    sub CNW_RXCONF_RXENA () {	0x80;}
}
unless(defined(&CNW_RXCONF_MAC)) {
    sub CNW_RXCONF_MAC () {	0x20;}
}
unless(defined(&CNW_RXCONF_PRO)) {
    sub CNW_RXCONF_PRO () {	0x10;}
}
unless(defined(&CNW_RXCONF_AMP)) {
    sub CNW_RXCONF_AMP () {	0x8;}
}
unless(defined(&CNW_RXCONF_BCAST)) {
    sub CNW_RXCONF_BCAST () {	0x4;}
}
unless(defined(&CNW_CMD_STC)) {
    sub CNW_CMD_STC () {	0x2;}
}
unless(defined(&CNW_TXCONF_TXENA)) {
    sub CNW_TXCONF_TXENA () {	0x80;}
}
unless(defined(&CNW_TXCONF_MAC)) {
    sub CNW_TXCONF_MAC () {	0x20;}
}
unless(defined(&CNW_TXCONF_EUD)) {
    sub CNW_TXCONF_EUD () {	0x10;}
}
unless(defined(&CNW_TXCONF_KEY)) {
    sub CNW_TXCONF_KEY () {	0x2;}
}
unless(defined(&CNW_TXCONF_LOOP)) {
    sub CNW_TXCONF_LOOP () {	0x1;}
}
unless(defined(&CNW_CMD_AMA)) {
    sub CNW_CMD_AMA () {	0x3;}
}
unless(defined(&CNW_CMD_DMA)) {
    sub CNW_CMD_DMA () {	0x4;}
}
unless(defined(&CNW_CMD_SAMA)) {
    sub CNW_CMD_SAMA () {	0x5;}
}
unless(defined(&CNW_CMD_ER)) {
    sub CNW_CMD_ER () {	0x6;}
}
unless(defined(&CNW_CMD_DR)) {
    sub CNW_CMD_DR () {	0x7;}
}
unless(defined(&CNW_CMD_TL)) {
    sub CNW_CMD_TL () {	0x8;}
}
unless(defined(&CNW_CMD_SRP)) {
    sub CNW_CMD_SRP () {	0x9;}
}
unless(defined(&CNW_CMD_SSK)) {
    sub CNW_CMD_SSK () {	0xa;}
}
unless(defined(&CNW_CMD_SMD)) {
    sub CNW_CMD_SMD () {	0xb;}
}
unless(defined(&CNW_CMD_SAPD)) {
    sub CNW_CMD_SAPD () {	0xc;}
}
unless(defined(&CNW_CMD_SSS)) {
    sub CNW_CMD_SSS () {	0x11;}
}
unless(defined(&CNW_CMD_EOC)) {
    sub CNW_CMD_EOC () {	0x;}
}
1;
