require '_h2ph_pre.ph';

no warnings 'redefine';

require 'sys/queue.ph';
unless(defined(&ATTACHED)) {
    sub ATTACHED () {	0x1;}
}
unless(defined(&UNDONE)) {
    sub UNDONE () {	0x2;}
}
unless(defined(&COMPLETE)) {
    sub COMPLETE () {	0x4;}
}
unless(defined(&DEPCOMPLETE)) {
    sub DEPCOMPLETE () {	0x8;}
}
unless(defined(&MKDIR_PARENT)) {
    sub MKDIR_PARENT () {	0x10;}
}
unless(defined(&MKDIR_BODY)) {
    sub MKDIR_BODY () {	0x20;}
}
unless(defined(&RMDIR)) {
    sub RMDIR () {	0x40;}
}
unless(defined(&DIRCHG)) {
    sub DIRCHG () {	0x80;}
}
unless(defined(&GOINGAWAY)) {
    sub GOINGAWAY () {	0x100;}
}
unless(defined(&IOSTARTED)) {
    sub IOSTARTED () {	0x200;}
}
unless(defined(&SPACECOUNTED)) {
    sub SPACECOUNTED () {	0x400;}
}
unless(defined(&NEWBLOCK)) {
    sub NEWBLOCK () {	0x800;}
}
unless(defined(&UFS1FMT)) {
    sub UFS1FMT () {	0x2000;}
}
unless(defined(&ONWORKLIST)) {
    sub ONWORKLIST () {	0x8000;}
}
unless(defined(&ALLCOMPLETE)) {
    sub ALLCOMPLETE () {	( &ATTACHED |  &COMPLETE |  &DEPCOMPLETE);}
}
unless(defined(&DEP_BITS)) {
    sub DEP_BITS () {	"\020\01ATTACHED\02UNDONE\03COMPLETE\04DEPCOMPLETE" "\05MKDIR_PARENT\06MKDIR_BODY\07RMDIR\010DIRCHG\011GOINGAWAY" "\012IOSTARTED\013SPACECOUNTED\014NEWBLOCK\016UFS1FMT\020ONWORKLIST";}
}
unless(defined(&WK_DATA)) {
    sub WK_DATA {
	my($wk) = @_;
	eval q((( &void *)($wk)));
    }
}
unless(defined(&WK_PAGEDEP)) {
    sub WK_PAGEDEP {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_INODEDEP)) {
    sub WK_INODEDEP {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_NEWBLK)) {
    sub WK_NEWBLK {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_BMSAFEMAP)) {
    sub WK_BMSAFEMAP {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_ALLOCDIRECT)) {
    sub WK_ALLOCDIRECT {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_INDIRDEP)) {
    sub WK_INDIRDEP {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_ALLOCINDIR)) {
    sub WK_ALLOCINDIR {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_FREEFRAG)) {
    sub WK_FREEFRAG {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_FREEBLKS)) {
    sub WK_FREEBLKS {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_FREEFILE)) {
    sub WK_FREEFILE {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_DIRADD)) {
    sub WK_DIRADD {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_MKDIR)) {
    sub WK_MKDIR {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_DIRREM)) {
    sub WK_DIRREM {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_NEWDIRBLK)) {
    sub WK_NEWDIRBLK {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&DAHASHSZ)) {
    sub DAHASHSZ () {	6;}
}
unless(defined(&DIRADDHASH)) {
    sub DIRADDHASH {
	my($offset) = @_;
	eval q(((($offset) >> 2) %  &DAHASHSZ));
    }
}
unless(defined(&pd_state)) {
    sub pd_state () {	 ($pd_list->{wk_state});}
}
unless(defined(&id_state)) {
    sub id_state () {	 ($id_list->{wk_state});}
}
unless(defined(&id_savedino1)) {
    sub id_savedino1 () {	 ($id_un->{idu_savedino1});}
}
unless(defined(&id_savedino2)) {
    sub id_savedino2 () {	 ($id_un->{idu_savedino2});}
}
unless(defined(&ad_state)) {
    sub ad_state () {	 ($ad_list->{wk_state});}
}
unless(defined(&ir_state)) {
    sub ir_state () {	 ($ir_list->{wk_state});}
}
unless(defined(&ai_state)) {
    sub ai_state () {	 ($ai_list->{wk_state});}
}
unless(defined(&ff_state)) {
    sub ff_state () {	 ($ff_list->{wk_state});}
}
unless(defined(&fb_state)) {
    sub fb_state () {	 ($fb_list->{wk_state});}
}
unless(defined(&da_state)) {
    sub da_state () {	 ($da_list->{wk_state});}
}
unless(defined(&da_previous)) {
    sub da_previous () {	 ($da_un->{dau_previous});}
}
unless(defined(&da_pagedep)) {
    sub da_pagedep () {	 ($da_un->{dau_pagedep});}
}
unless(defined(&md_state)) {
    sub md_state () {	 ($md_list->{wk_state});}
}
unless(defined(&dm_state)) {
    sub dm_state () {	 ($dm_list->{wk_state});}
}
unless(defined(&dm_pagedep)) {
    sub dm_pagedep () {	 ($dm_un->{dmu_pagedep});}
}
unless(defined(&dm_dirinum)) {
    sub dm_dirinum () {	 ($dm_un->{dmu_dirinum});}
}
unless(defined(&db_state)) {
    sub db_state () {	 ($db_list->{wk_state});}
}
1;
